// Weapon_Dodgeball.cs
// Inspired by Chao.

datablock ParticleData(Dodgeball_TrailParticle)
{
	dragCoefficient = 3.0;
	windCoefficient = 0.0;
	gravityCoefficient = 0.0;
	inheritedVelFactor = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS = 600;
	lifetimeVarianceMS = 0;
	spinSpeed = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	useInvAlpha = true;
	animateTexture = false;

	textureName	= "base/data/particles/dot";

	colors[0]	= "1 1 1 0.3";
	colors[1]	= "1 1 1 0.2";
	colors[2]	= "0 0 0 0";
	sizes[0]	= 1.0;
	sizes[1]	= 0.0;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.6;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(Dodgeball_TrailEmitter)
{
	ejectionPeriodMS = 5;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	ejectionOffset = 0;
	thetaMin = 0.0;
	thetaMax = 0.0;  
	particles = Dodgeball_TrailParticle;
	useEmitterColors = true;
	uiName = "";
};

AddDamageType("DodgeballDirect",   '<bitmap:add-ons/Weapon_DemiansDodgeball/CI_Dodgeball> %1',       '%2 <bitmap:add-ons/Weapon_DemiansDodgeball/CI_Dodgeball> %1',1,1);

datablock ProjectileData(Dodgeball_Projectile)
{
	projectileShapeName = "./Dodgeball.dts";
	directDamage = 100000;
	directDamageType = $DamageType::DodgeballDirect;
	impactImpulse = 1000;
	verticalImpulse	= 1000;
	particleEmitter = Dodgeball_TrailEmitter;

	brickExplosionRadius = 0;
	brickExplosionImpact = false;
	brickExplosionForce = 0;
	brickExplosionMaxVolume = 0;
	brickExplosionMaxVolumeFloating = 0;
   
	muzzleVelocity = 50;
	velInheritFactor = 1;

	armingDelay = 3900;
	lifetime = 4000;
	fadeDelay = 19500;
	bounceElasticity = 0.7;
	bounceFriction = 0.3;
	isBallistic = true;
	gravityMod = 1.0;
	
	hasLight = false;
	lightRadius = 1.0;
	lightColor = "0 0 0";
	
	uiName = "Dodgeball";
};

datablock ItemData(Dodgeball_Item)
{
	category  = "Weapon";
	className = "Weapon";

	shapeFile  = "./Dodgeball.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Dodgeball";
	iconName  = "./icon_Dodgeball";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";

	image = Dodgeball_Image;
	canDrop = true;
};

datablock ShapeBaseImageData(Dodgeball_Image)
{
	shapeFile  = "./Dodgeball.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";

	correctMuzzleVector = true;

	className = "WeaponImage";
	
	item = Dodgeball_Item;
	ammo = " ";
	projectile = Dodgeball_Projectile;
	projectileType = Projectile;

	melee = false;
	armReady = true;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]			= "ready";
	stateSound[0]				= weaponSwitchSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]		= true;
	
	stateName[2]                  = "Charge";
	stateTransitionOnTimeout[2]	  = "Armed";
	stateTimeoutValue[2]          = 0.6;
	stateWaitForTimeout[2]		  = false;
	stateTransitionOnTriggerUp[2] = "AbortCharge";
	stateScript[2]                = "onCharge";
	stateAllowImageChange[2]      = false;
	
	stateName[3]				= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.2;
	stateWaitForTimeout[3]		= true;
	stateScript[3]				= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]				  = "Armed";
	stateTransitionOnTriggerUp[4] = "Fire";
	stateAllowImageChange[4]	  = false;

	stateName[5]				= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.4;
	stateFire[5]				= true;
	stateSequence[5]			= "fire";
	stateScript[5]				= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= SpearFireSound;
};

function Dodgeball_Image::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function Dodgeball_Image::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function Dodgeball_Image::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}
//----------------Red Dodgeball----------------

datablock ParticleData(RedDodgeball_TrailParticle : Dodgeball_TrailParticle)
{
	colors[0]	= "0.9 0 0 0.3";
	colors[1]	= "1 1 1 0.2";
	colors[2]	= "0 0 0 0";
	sizes[0]	= 1.0;
	sizes[1]	= 0.0;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.6;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(RedDodgeball_TrailEmitter : Dodgeball_TrailEmitter)
{
	particles = RedDodgeball_TrailParticle;
};

datablock ProjectileData(RedDodgeball_Projectile : Dodgeball_Projectile)
{
	projectileShapeName = "./RedDodgeball.dts";
	particleEmitter = RedDodgeball_TrailEmitter;
	uiName = "Red Dodgeball";
};

datablock ItemData(RedDodgeball_Item : Dodgeball_Item)
{
	shapeFile  = "./RedDodgeball.dts";
	uiName = "Red Dodgeball";
	doColorShift = true;
	colorShiftColor = "1 0 0 1";
	image = RedDodgeball_Image;
};

datablock ShapeBaseImageData(RedDodgeball_Image : Dodgeball_Image)
{
	shapeFile  = "./RedDodgeball.dts";
	item = RedDodgeball_Item;
	projectile = RedDodgeball_Projectile;
};

function RedDodgeball_Image::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function RedDodgeball_Image::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function RedDodgeball_Image::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}

//----------------Green Dodgeball----------------

datablock ParticleData(GreenDodgeball_TrailParticle : Dodgeball_TrailParticle)
{
	colors[0]	= "0 0.9 0 0.3";
	colors[1]	= "1 1 1 0.2";
	colors[2]	= "0 0 0 0";
	sizes[0]	= 1.0;
	sizes[1]	= 0.0;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.6;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(GreenDodgeball_TrailEmitter : Dodgeball_TrailEmitter)
{
	particles = GreenDodgeball_TrailParticle;
};

datablock ProjectileData(GreenDodgeball_Projectile : Dodgeball_Projectile)
{
	projectileShapeName = "./GreenDodgeball.dts";
	particleEmitter = GreenDodgeball_TrailEmitter;
	uiName = "Green Dodgeball";
};

datablock ItemData(GreenDodgeball_Item : Dodgeball_Item)
{
	shapeFile  = "./GreenDodgeball.dts";
	uiName = "Green Dodgeball";
	doColorShift = true;
	colorShiftColor = "0 1 0 1";
	image = GreenDodgeball_Image;
};

datablock ShapeBaseImageData(GreenDodgeball_Image : Dodgeball_Image)
{
	shapeFile  = "./GreenDodgeball.dts";
	item = GreenDodgeball_Item;
	projectile = GreenDodgeball_Projectile;
};

function GreenDodgeball_Image::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function GreenDodgeball_Image::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function GreenDodgeball_Image::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}

//----------------Blue Dodgeball----------------

datablock ParticleData(BlueDodgeball_TrailParticle : Dodgeball_TrailParticle)
{
	colors[0]	= "0 0 0.9 0.3";
	colors[1]	= "1 1 1 0.2";
	colors[2]	= "0 0 0 0";
	sizes[0]	= 1.0;
	sizes[1]	= 0.0;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.6;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(BlueDodgeball_TrailEmitter : Dodgeball_TrailEmitter)
{
	particles = BlueDodgeball_TrailParticle;
};

datablock ProjectileData(BlueDodgeball_Projectile : Dodgeball_Projectile)
{
	projectileShapeName = "./BlueDodgeball.dts";
	particleEmitter = BlueDodgeball_TrailEmitter;
	uiName = "Blue Dodgeball";
};

datablock ItemData(BlueDodgeball_Item : Dodgeball_Item)
{
	shapeFile  = "./BlueDodgeball.dts";
	uiName = "Blue Dodgeball";
	doColorShift = true;
	colorShiftColor = "0 0 1 1";
	image = BlueDodgeball_Image;
};

datablock ShapeBaseImageData(BlueDodgeball_Image : Dodgeball_Image)
{
	shapeFile  = "./BlueDodgeball.dts";
	item = BlueDodgeball_Item;
	projectile = BlueDodgeball_Projectile;
};

function BlueDodgeball_Image::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function BlueDodgeball_Image::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function BlueDodgeball_Image::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}

//----------------Yellow Dodgeball----------------

datablock ParticleData(YellowDodgeball_TrailParticle : Dodgeball_TrailParticle)
{
	colors[0]	= "0.9 0.9 0 0.3";
	colors[1]	= "1 1 1 0.2";
	colors[2]	= "0 0 0 0";
	sizes[0]	= 1.0;
	sizes[1]	= 0.0;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.6;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(YellowDodgeball_TrailEmitter : Dodgeball_TrailEmitter)
{
	particles = YellowDodgeball_TrailParticle;
};

datablock ProjectileData(YellowDodgeball_Projectile : Dodgeball_Projectile)
{
	projectileShapeName = "./YellowDodgeball.dts";
	particleEmitter = YellowDodgeball_TrailEmitter;
	uiName = "Yellow Dodgeball";
};

datablock ItemData(YellowDodgeball_Item : Dodgeball_Item)
{
	shapeFile  = "./YellowDodgeball.dts";
	uiName = "Yellow Dodgeball";
	doColorShift = true;
	colorShiftColor = "1 1 0 1";
	image = YellowDodgeball_Image;
};

datablock ShapeBaseImageData(YellowDodgeball_Image : Dodgeball_Image)
{
	shapeFile  = "./YellowDodgeball.dts";
	item = YellowDodgeball_Item;
	projectile = YellowDodgeball_Projectile;
};

function YellowDodgeball_Image::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function YellowDodgeball_Image::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function YellowDodgeball_Image::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}